<template>
  <a-modal
    :title="title"
    :width="800"
    :visible="visible"
    ok-text="保存并安排任务"
    cancel-text="关闭"
    @ok="handleOk"
    @cancel="handleCancel"
  >
    <a-spin>
      <a-form :form="form">
        <a-form-item
          :label-col="labelCol"
          :wrapper-col="wrapperCol"
          label="任务类名"
          has-feedback
        >
          <a-input
            v-decorator="[
              'jobClassName',
              { rules: [{ required: true, message: '请输入任务类名!' }] },
            ]"
            placeholder="请输入任务类名"
          />
        </a-form-item>
        <a-form-item
          :label-col="labelCol"
          :wrapper-col="wrapperCol"
          label="cron表达式"
        >
          <j-cron
            ref="innerVueCron"
            v-decorator="[
              'cronExpression',
              {
                initialValue: '0/1 * * * * ?',
                rules: [{ required: true, message: '请输入cron表达式!' }],
              },
            ]"
            @change="setCorn"
          ></j-cron>
        </a-form-item>
        <a-form-item
          :label-col="labelCol"
          :wrapper-col="wrapperCol"
          label="参数"
          has-feedback
        >
          <a-input v-decorator="['parameter', {}]" placeholder="请输入参数" />
        </a-form-item>
        <a-form-item
          :label-col="labelCol"
          :wrapper-col="wrapperCol"
          label="描述"
          has-feedback
        >
          <a-input v-decorator="['description', {}]" placeholder="请输入描述" />
        </a-form-item>
        <a-form-item
          :label-col="labelCol"
          :wrapper-col="wrapperCol"
          label="状态"
        >
          <a-radio-group
            v-decorator="['status', { initialValue: 0 }]"
            button-style="solid"
          >
            <a-radio-button :value="0">正常</a-radio-button>
            <a-radio-button :value="-1">停止</a-radio-button>
          </a-radio-group>
        </a-form-item>
      </a-form>
    </a-spin>
  </a-modal>
</template>

<script>
import { pick } from "lodash";
import moment from "moment";
// import { httpAction } from "@/api/manage";
import JCron from "@/components/model/JCron.vue";

export default {
  name: "QuartzJobModal",
  components: {
    JCron,
  },
  data() {
    return {
      title: "操作",
      visible: false,
      model: {},
      labelCol: {
        xs: { span: 24 },
        sm: { span: 5 },
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 },
      },
      cron: {
        label: "",
        value: "",
      },
      form: this.$form.createForm(this),
      validatorRules: {
        cron: {
          rules: [
            {
              required: true,
              message: "请输入cron表达式!",
            },
          ],
        },
      },
      url: {
        add: "/sys/quartzJob/add",
        edit: "/sys/quartzJob/edit",
      },
    };
  },
  created() {},
  methods: {
    add() {
      this.edit({});
    },
    edit(record) {
      this.model = { ...record };
      this.visible = true;
      this.$nextTick(() => {
        this.form.setFieldsValue(
          pick(
            this.model,
            "jobClassName",
            "cronExpression",
            "parameter",
            "description",
            "status"
          )
        );
      });
    },
    close() {
      this.$emit("close");
      this.visible = false;
    },
    handleOk() {
      // 触发表单验证
      this.form.validateFields((err, values) => {
        if (!err) {
          let httpurl = "";
          let method = "";
          if (!this.model.id) {
            httpurl += this.url.add;
            method = "post";
          } else {
            httpurl += this.url.edit;
            method = "put";
          }
          const formData = Object.assign(this.model, values);
          // 时间格式化
          // httpAction(httpurl, formData, method)
          //   .then((res) => {
          //     if (res.success) {
          //       this.$message.success(res.message);
          //       this.$emit("ok");
          //     } else {
          //       this.$message.warning(res.message);
          //     }
          //   })
          //   .finally(() => {
          //     this.close();
          //   });
        }
      });
    },
    handleCancel() {
      this.close();
    },
    setCorn(data) {
      this.$nextTick(() => {
        this.model.cronExpression = data;
      });
    },
    validateCron(rule, value, callback) {
      if (!value) {
        callback();
      } else if (Object.keys(value).length === 0) {
        callback(new Error("请输入cron表达式!"));
      }
    },
  },
};
</script>
